## org.apache.myfaces.renderkit.html
Class HtmlTableRendererBase

    java.lang.Object
      javax.faces.render.Renderer
          org.apache.myfaces.renderkit.html.HtmlRenderer
              org.apache.myfaces.renderkit.html.HtmlTableRendererBase

Direct Known Subclasses:
  HtmlTableRenderer

public class HtmlTableRendererBase
extends HtmlRenderer

Version:
  $Revision: 279726 $ $Date: 2005-09-09 03:50:08 -0400 (Fri, 09 Sep 2005) $
Author:
  Thomas Spiegl (latest modification by $Author: svieujot $)

Field Summary
`protected static java.lang.String` `FOOTER_FACET_NAME` Footer facet name.
`protected static java.lang.String` `HEADER_FACET_NAME` Header facet name.

Constructor Summary
`HtmlTableRendererBase()`

Method Summary
`protected void` `afterRow(javax.faces.context.FacesContext facesContext, javax.faces.component.UIData uiData)` Convenient method for derived table renderers.
`protected void` `afterTable(javax.faces.context.FacesContext facesContext, javax.faces.component.UIData uiData)` Convenient method for derived table renderers.
`protected void` `beforeRow(javax.faces.context.FacesContext facesContext, javax.faces.component.UIData uiData)` Convenient method for derived table renderers.
`protected void` `beforeTable(javax.faces.context.FacesContext facesContext, javax.faces.component.UIData uiData)` Convenient method for derived table renderers.
`void` `decode(javax.faces.context.FacesContext context, javax.faces.component.UIComponent component)`
`protected int` `determineChildColSpan(javax.faces.component.UIComponent uiComponent)`
`void` `encodeBegin(javax.faces.context.FacesContext facesContext, javax.faces.component.UIComponent uiComponent)`
`void` `encodeChildren(javax.faces.context.FacesContext facesContext, javax.faces.component.UIComponent component)`
`protected void` `encodeColumnChild(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, javax.faces.component.UIData uiData, javax.faces.component.UIComponent component, java.util.Iterator columnStyleIterator)`
`void` `encodeEnd(javax.faces.context.FacesContext facesContext, javax.faces.component.UIComponent uiComponent)`
`void` `encodeInnerHtml(javax.faces.context.FacesContext facesContext, javax.faces.component.UIComponent component)` Renders everything inside the tag. currently used for the autoUpdateDataTable
`protected static java.lang.String` `getFooterClass(javax.faces.component.UIComponent component)` Gets the footerClass attribute of the given `UIComponent`.
`protected static java.lang.String` `getHeaderClass(javax.faces.component.UIComponent component)` Gets the headerClass attribute of the given `UIComponent`.
`boolean` `getRendersChildren()`
`protected boolean` `hasFacet(boolean header, javax.faces.component.UIComponent uiComponent)`
`protected void` `renderColumnBody(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, javax.faces.component.UIData uiData, javax.faces.component.UIComponent component, java.util.Iterator columnStyleIterator)` Renders the body of a given `UIColumn` (everything but the header and footer facets).
`protected void` `renderColumnChildHeaderOrFooterRow(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, javax.faces.component.UIComponent uiComponent, java.lang.String styleClass, boolean header)`
`protected void` `renderColumnFooterCell(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, javax.faces.component.UIColumn uiColumn, java.lang.String footerStyleClass, int colspan)` Renders the footer facet for the given `UIColumn`.
`protected void` `renderColumnFooterCell(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, javax.faces.component.UIComponent uiComponent, javax.faces.component.UIComponent facet, java.lang.String footerStyleClass, int colspan)` Renders the footer facet for the given `UIColumn`.
`protected void` `renderColumnFooterRow(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, javax.faces.component.UIComponent component, java.lang.String footerStyleClass)` Renders the footer row for the columns, which is a separate row from the footer row for the `UIData` footer facet.
`protected void` `renderColumnHeaderCell(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, javax.faces.component.UIColumn uiColumn, java.lang.String headerStyleClass, int colspan)` Renders the header facet for the given `UIColumn`.
`protected void` `renderColumnHeaderCell(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, javax.faces.component.UIComponent uiComponent, javax.faces.component.UIComponent facet, java.lang.String headerStyleClass, int colspan)` Renders the header facet for the given `UIColumn`.
`protected void` `renderColumnHeaderRow(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, javax.faces.component.UIComponent component, java.lang.String headerStyleClass)` Renders the header row for the columns, which is a separate row from the header row for the `UIData` header facet.
`protected void` `renderFacet(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, javax.faces.component.UIComponent component, boolean header)` Renders either the header or the footer facets.
`protected void` `renderRowEnd(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, javax.faces.component.UIData uiData)` Renders the end of a row of body content.
`protected void` `renderRowStart(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, javax.faces.component.UIData uiData, java.util.Iterator rowStyleIterator)` Renders the start of a new row of body content.
`protected void` `renderRowStyle(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, javax.faces.component.UIData uiData, java.util.Iterator rowStyleIterator)`
`protected void` `renderTableFooterRow(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, javax.faces.component.UIComponent component, javax.faces.component.UIComponent footerFacet, java.lang.String footerStyleClass, int colspan)` Renders the footer row of the table being rendered.
`protected void` `renderTableHeaderRow(javax.faces.context.FacesContext facesContext, javax.faces.context.ResponseWriter writer, javax.faces.component.UIComponent component, javax.faces.component.UIComponent headerFacet, java.lang.String headerStyleClass, int colspan)` Renders the header row of the table being rendered.

Methods inherited from class javax.faces.render.Renderer
`convertClientId, getConvertedValue`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### HEADER_FACET_NAME

    protected static final java.lang.String HEADER_FACET_NAME

  Header facet name.

  See Also:
    Constant Field Values

### FOOTER_FACET_NAME

    protected static final java.lang.String FOOTER_FACET_NAME

  Footer facet name.

  See Also:
    Constant Field Values

Constructor Detail

### HtmlTableRendererBase

    public HtmlTableRendererBase()

Method Detail

### getRendersChildren

    public boolean getRendersChildren()

  See Also:
    `Renderer.getRendersChildren()`

### encodeBegin

    public void encodeBegin(javax.faces.context.FacesContext facesContext,
                            javax.faces.component.UIComponent uiComponent)
                     throws java.io.IOException

  Throws:
    `java.io.IOException`
  See Also:
    `Renderer.encodeBegin(FacesContext, UIComponent)`

### encodeChildren

    public void encodeChildren(javax.faces.context.FacesContext facesContext,
                               javax.faces.component.UIComponent component)
                        throws java.io.IOException

  Overrides:
    `encodeChildren` in class `HtmlRenderer`
  Throws:
    `java.io.IOException`
  See Also:
    `Renderer.encodeChildren(FacesContext, UIComponent)`

### encodeInnerHtml

    public void encodeInnerHtml(javax.faces.context.FacesContext facesContext,
                                javax.faces.component.UIComponent component)
                         throws java.io.IOException

  Renders everything inside the
  tag. currently used for the autoUpdateDataTable

  Throws:
    `java.io.IOException`

### encodeColumnChild

    protected void encodeColumnChild(javax.faces.context.FacesContext facesContext,
                                     javax.faces.context.ResponseWriter writer,
                                     javax.faces.component.UIData uiData,
                                     javax.faces.component.UIComponent component,
                                     java.util.Iterator columnStyleIterator)
                              throws java.io.IOException

  Throws:
    `java.io.IOException`

### renderColumnBody

    protected void renderColumnBody(javax.faces.context.FacesContext facesContext,
                                    javax.faces.context.ResponseWriter writer,
                                    javax.faces.component.UIData uiData,
                                    javax.faces.component.UIComponent component,
                                    java.util.Iterator columnStyleIterator)
                             throws java.io.IOException

  Renders the body of a given `UIColumn` (everything but the header and footer facets).

  Parameters:
    `facesContext` - the `FacesContext`.
    `writer` - the `ResponseWriter`.
    `uiData` - the `UIData` being rendered.
    `component` - the `UIComponent` to render.
    `columnStyleIterator` - the styleClass of the `UIColumn` or `null` if there is none.
  Throws:
    `java.io.IOException` - if an exception occurs.

### renderRowStart

    protected void renderRowStart(javax.faces.context.FacesContext facesContext,
                                  javax.faces.context.ResponseWriter writer,
                                  javax.faces.component.UIData uiData,
                                  java.util.Iterator rowStyleIterator)
                           throws java.io.IOException

  Renders the start of a new row of body content.

  Parameters:
    `facesContext` - the `FacesContext`.
    `writer` - the `ResponseWriter`.
    `uiData` - the `UIData` being rendered.
    `rowStyleIterator` - te styleClass of the row or `null` if there is none.
  Throws:
    `java.io.IOException` - if an exceptoin occurs.

### renderRowStyle

    protected void renderRowStyle(javax.faces.context.FacesContext facesContext,
                                  javax.faces.context.ResponseWriter writer,
                                  javax.faces.component.UIData uiData,
                                  java.util.Iterator rowStyleIterator)
                           throws java.io.IOException

  Throws:
    `java.io.IOException`

### renderRowEnd

    protected void renderRowEnd(javax.faces.context.FacesContext facesContext,
                                javax.faces.context.ResponseWriter writer,
                                javax.faces.component.UIData uiData)
                         throws java.io.IOException

  Renders the end of a row of body content.

  Parameters:
    `facesContext` - the `FacesContext`.
    `writer` - the `ResponseWriter`.
    `uiData` - the `UIData` being rendered.
  Throws:
    `java.io.IOException` - if an exceptoin occurs.

### beforeTable

    protected void beforeTable(javax.faces.context.FacesContext facesContext,
                               javax.faces.component.UIData uiData)
                        throws java.io.IOException

  Convenient method for derived table renderers.

  Parameters:
    `facesContext` - the `FacesContext`.
    `uiData` - the `UIData` being rendered.
  Throws:
    `java.io.IOException`

### beforeRow

    protected void beforeRow(javax.faces.context.FacesContext facesContext,
                             javax.faces.component.UIData uiData)
                      throws java.io.IOException

  Convenient method for derived table renderers.

  Parameters:
    `facesContext` - the `FacesContext`.
    `uiData` - the `UIData` being rendered.
  Throws:
    `java.io.IOException`

### afterRow

    protected void afterRow(javax.faces.context.FacesContext facesContext,
                            javax.faces.component.UIData uiData)
                     throws java.io.IOException

  Convenient method for derived table renderers.

  Parameters:
    `facesContext` - the `FacesContext`.
    `uiData` - the `UIData` being rendered.
  Throws:
    `java.io.IOException`

### afterTable

    protected void afterTable(javax.faces.context.FacesContext facesContext,
                              javax.faces.component.UIData uiData)
                       throws java.io.IOException

  Convenient method for derived table renderers.

  Parameters:
    `facesContext` - the `FacesContext`.
    `uiData` - the `UIData` being rendered.
  Throws:
    `java.io.IOException`

### encodeEnd

    public void encodeEnd(javax.faces.context.FacesContext facesContext,
                          javax.faces.component.UIComponent uiComponent)
                   throws java.io.IOException

  Throws:
    `java.io.IOException`
  See Also:
    `Renderer.encodeEnd(FacesContext, UIComponent)`

### renderFacet

    protected void renderFacet(javax.faces.context.FacesContext facesContext,
                               javax.faces.context.ResponseWriter writer,
                               javax.faces.component.UIComponent component,
                               boolean header)
                        throws java.io.IOException

  Renders either the header or the footer facets.

  Parameters:
    `facesContext` - the `FacesContext`.
    `writer` - the `ResponseWriter`.
    `component` - the parent `UIComponent` containing the facets.
    `header` - whether this is the header facet (if not, then the footer facet).
  Throws:
    `java.io.IOException` - if an exception occurs.

### hasFacet

    protected boolean hasFacet(boolean header,
                               javax.faces.component.UIComponent uiComponent)

  Parameters:
    `header` -
    `uiComponent` -
  Returns:
    boolean

### determineChildColSpan

    protected int determineChildColSpan(javax.faces.component.UIComponent uiComponent)

### renderTableHeaderRow

    protected void renderTableHeaderRow(javax.faces.context.FacesContext facesContext,
                                        javax.faces.context.ResponseWriter writer,
                                        javax.faces.component.UIComponent component,
                                        javax.faces.component.UIComponent headerFacet,
                                        java.lang.String headerStyleClass,
                                        int colspan)
                                 throws java.io.IOException

  Renders the header row of the table being rendered.

  Parameters:
    `facesContext` - the `FacesContext`.
    `writer` - the `ResponseWriter`.
    `component` - the `UIComponent` for whom a table is being rendered.
    `headerFacet` - the facet for the header.
    `headerStyleClass` - the styleClass of the header.
    `colspan` - the number of columns the header should span. Typically, this is the number of columns in the table.
  Throws:
    `java.io.IOException` - if an exception occurs.

### renderTableFooterRow

    protected void renderTableFooterRow(javax.faces.context.FacesContext facesContext,
                                        javax.faces.context.ResponseWriter writer,
                                        javax.faces.component.UIComponent component,
                                        javax.faces.component.UIComponent footerFacet,
                                        java.lang.String footerStyleClass,
                                        int colspan)
                                 throws java.io.IOException

  Renders the footer row of the table being rendered.

  Parameters:
    `facesContext` - the `FacesContext`.
    `writer` - the `ResponseWriter`.
    `component` - the `UIComponent` for whom a table is being rendered.
    `footerFacet` - the facet for the footer.
    `footerStyleClass` - the styleClass of the footer.
    `colspan` - the number of columns the header should span. Typically, this is the number of columns in the table.
  Throws:
    `java.io.IOException` - if an exception occurs.

### renderColumnHeaderRow

    protected void renderColumnHeaderRow(javax.faces.context.FacesContext facesContext,
                                         javax.faces.context.ResponseWriter writer,
                                         javax.faces.component.UIComponent component,
                                         java.lang.String headerStyleClass)
                                  throws java.io.IOException

  Renders the header row for the columns, which is a separate row from the header row for the `UIData` header facet.

  Parameters:
    `facesContext` - the `FacesContext`.
    `writer` - the `ResponseWriter`.
    `component` - the `UIComponent` for whom a table is being rendered.
    `headerStyleClass` - the styleClass of the header
  Throws:
    `java.io.IOException` - if an exception occurs.

### renderColumnFooterRow

    protected void renderColumnFooterRow(javax.faces.context.FacesContext facesContext,
                                         javax.faces.context.ResponseWriter writer,
                                         javax.faces.component.UIComponent component,
                                         java.lang.String footerStyleClass)
                                  throws java.io.IOException

  Renders the footer row for the columns, which is a separate row from the footer row for the `UIData` footer facet.

  Parameters:
    `facesContext` - the `FacesContext`.
    `writer` - the `ResponseWriter`.
    `component` - the `UIComponent` for whom a table is being rendered.
    `footerStyleClass` - the styleClass of the footerStyleClass
  Throws:
    `java.io.IOException` - if an exception occurs.

### renderColumnChildHeaderOrFooterRow

    protected void renderColumnChildHeaderOrFooterRow(javax.faces.context.FacesContext facesContext,
                                                      javax.faces.context.ResponseWriter writer,
                                                      javax.faces.component.UIComponent uiComponent,
                                                      java.lang.String styleClass,
                                                      boolean header)
                                               throws java.io.IOException

  Throws:
    `java.io.IOException`

### renderColumnHeaderCell

    protected void renderColumnHeaderCell(javax.faces.context.FacesContext facesContext,
                                          javax.faces.context.ResponseWriter writer,
                                          javax.faces.component.UIColumn uiColumn,
                                          java.lang.String headerStyleClass,
                                          int colspan)
                                   throws java.io.IOException

  Renders the header facet for the given `UIColumn`.

  Parameters:
    `facesContext` - the `FacesContext`.
    `writer` - the `ResponseWriter`.
    `uiColumn` - the `UIColumn`.
    `headerStyleClass` - the styleClass of the header facet.
    `colspan` - the colspan for the tableData element in which the header facet will be wrapped.
  Throws:
    `java.io.IOException`

### renderColumnHeaderCell

    protected void renderColumnHeaderCell(javax.faces.context.FacesContext facesContext,
                                          javax.faces.context.ResponseWriter writer,
                                          javax.faces.component.UIComponent uiComponent,
                                          javax.faces.component.UIComponent facet,
                                          java.lang.String headerStyleClass,
                                          int colspan)
                                   throws java.io.IOException

  Renders the header facet for the given `UIColumn`.

  Parameters:
    `facesContext` - the `FacesContext`.
    `writer` - the `ResponseWriter`.
    `uiComponent` - the `UIComponent` to render the facet for.
    `facet` - the `UIComponent` to render as facet.
    `headerStyleClass` - the styleClass of the header facet.
    `colspan` - the colspan for the tableData element in which the header facet will be wrapped.
  Throws:
    `java.io.IOException`

### renderColumnFooterCell

    protected void renderColumnFooterCell(javax.faces.context.FacesContext facesContext,
                                          javax.faces.context.ResponseWriter writer,
                                          javax.faces.component.UIColumn uiColumn,
                                          java.lang.String footerStyleClass,
                                          int colspan)
                                   throws java.io.IOException

  Renders the footer facet for the given `UIColumn`.

  Parameters:
    `facesContext` - the `FacesContext`.
    `writer` - the `ResponseWriter`.
    `uiColumn` - the `UIComponent`.
    `footerStyleClass` - the styleClass of the footer facet.
    `colspan` - the colspan for the tableData element in which the footer facet will be wrapped.
  Throws:
    `java.io.IOException`

### renderColumnFooterCell

    protected void renderColumnFooterCell(javax.faces.context.FacesContext facesContext,
                                          javax.faces.context.ResponseWriter writer,
                                          javax.faces.component.UIComponent uiComponent,
                                          javax.faces.component.UIComponent facet,
                                          java.lang.String footerStyleClass,
                                          int colspan)
                                   throws java.io.IOException

  Renders the footer facet for the given `UIColumn`.

  Parameters:
    `facesContext` - the `FacesContext`.
    `writer` - the `ResponseWriter`.
    `uiComponent` - the `UIComponent` to render the facet for.
    `facet` - the `UIComponent` to render as facet.
    `footerStyleClass` - the styleClass of the footer facet.
    `colspan` - the colspan for the tableData element in which the footer facet will be wrapped.
  Throws:
    `java.io.IOException`

### getHeaderClass

    protected static java.lang.String getHeaderClass(javax.faces.component.UIComponent component)

  Gets the headerClass attribute of the given `UIComponent`.

  Parameters:
    `component` - the `UIComponent`.
  Returns:
    the headerClass attribute of the given `UIComponent`.

### getFooterClass

    protected static java.lang.String getFooterClass(javax.faces.component.UIComponent component)

  Gets the footerClass attribute of the given `UIComponent`.

  Parameters:
    `component` - the `UIComponent`.
  Returns:
    the footerClass attribute of the given `UIComponent`.

### decode

    public void decode(javax.faces.context.FacesContext context,
                       javax.faces.component.UIComponent component)